SWEP.PrintName = "PropPlacer"
SWEP.Instructions = "Left or right mouse to place a prop! Selected with selectprop."
SWEP.Spawnable = true
SWEP.AdminOnly = false
SWEP.Primary.ClipSize = -1
SWEP.Primary.DefaultClip = -1
SWEP.Primary.Automatic = false
SWEP.Primary.Ammo = "none"
SWEP.Secondary.ClipSize = -1
SWEP.Secondary.DefaultClip = -1
SWEP.Secondary.Automatic = false
SWEP.Secondary.Ammo = "none"
SWEP.Weight = 2
SWEP.AutoSwitchTo = false
SWEP.AutoSwitchFrom = false
SWEP.Slot = 0
SWEP.SlotPos = 3
SWEP.DrawAmmo = false
SWEP.DrawCrosshair = true
SWEP.AccurateCrosshair = true
SWEP.ViewModel = "models/weapons/v_slam.mdl"
SWEP.WorldModel = "models/weapons/w_slam.mdl"
if SERVER then return end
if (not propplacer or not propplacer.last_model) then -- don't remove values on hot reload
  propplacer = {last_model = nil, last_tick = 0, rotatepitch = 0, rotateroll = 0, rotateyaw = 0}
end
-- clientside variables
local ShootSound = Sound("garrysmod/balloon_pop_cute.wav")
SWEP.model = "models/balloons/balloon_dog.mdl"
SWEP.freeze = false
SWEP.angles = Angle(0, 0, 0)

SWEP.PrimaryAttack = function(self)
  if IsFirstTimePredicted() then
    self:EmitSound(ShootSound)
    if self.freeze then
      self:Place(self.model, self.last_pos + propplacer.last_model.aabb.min, (self.last_angles + self.angles))
      self.freeze = false
    else
      self:Place(self.model, self.Owner:GetEyeTrace().HitPos + propplacer.last_model.aabb.min, self.angles )
    end
  end
end

SWEP.SecondaryAttack = function(self)
  if IsFirstTimePredicted() then
    self.last_pos = self.Owner:GetEyeTrace().HitPos
    self.last_angles = Angle(0, 0, 0)
    self.freeze = not self.freeze
  end
end

SWEP.Reload = function(self)
  if IsFirstTimePredicted() then
    self["angles"] = Angle(0, 0, 0)
  end
end

SWEP.Holster = function(self)
  if propplacer.last_model and (LocalPlayer():SteamID64() == self.Owner:SteamID64()) then
    propplacer.last_model:Remove()
    propplacer.last_model = nil
  end
end

SWEP.DrawHUD = function(self)
  if not propplacer.last_model then
    propplacer.last_model = ClientsideModel(self.model, RENDERGROUP_TRANSLUCENT)
    if IsValid(propplacer.last_model) then
      local eyetrace = self.Owner:GetEyeTrace()
      local hitpos = eyetrace.HitPos
      propplacer.last_model:SetModel(self.model)
      propplacer.last_model:SetCollisionGroup(COLLISION_GROUP_WORLD)
      propplacer.last_model:SetRenderFX(kRenderFxDistort)--PulseFastWide)
      propplacer.last_model:SetRenderMode(RENDERMODE_TRANSALPHA)
      propplacer.last_model:SetPos(hitpos)
      propplacer.last_model:SetAngles(Angle(0,0,0))
      propplacer.last_model:Spawn()
      propplacer.last_model:PhysicsInit(SOLID_VPHYSICS) 
      propplacer.last_model:SetSolid(SOLID_VPHYSICS)

      propplacer.last_model.phys = propplacer.last_model:GetPhysicsObject()
      local aabb = {}
      propplacer.last_model.aabb = {}

      if IsValid(propplacer.last_model.phys) then
        local min, max = propplacer.last_model.phys:GetAABB()
        aabb.min = min
        aabb.max = max
        propplacer.last_model.aabb.min = aabb.min
        propplacer.last_model.aabb.max = aabb.max
        propplacer.last_model:SetPos(hitpos + aabb.min)
      else
	propplacer.last_model.aabb.max = Vector(0, 0, 0)
	propplacer.last_model.aabb.min = Vector(0, 0, 0)
      end
    end
  else
    if self.freeze then
      --propplacer.last_model:SetPos(self.last_pos)
      --no need to set new pos, right?
      --if it is checked up in freeze state anyway
      --TODO: set model in init based on freeze state
      propplacer.last_model:SetAngles((self.last_angles + self.angles))
    else
      propplacer.last_model:SetPos(self.Owner:GetEyeTrace().HitPos + propplacer.last_model.aabb.min)
      propplacer.last_model:SetAngles(self.angles)
    end
  end
end

SWEP.Think = function(self)
  if propplacer.last_model and (LocalPlayer():SteamID64() == self.Owner:SteamID64()) then
    if (propplacer.rotateyaw ~= 0) then
      return self.Owner:ConCommand(("rotatepropyaw " .. propplacer.rotateyaw))
    end
    if (propplacer.rotatepitch ~= 0) then
      return self.Owner:ConCommand(("rotateproppitch " .. propplacer.rotatepitch))
    end
    if (propplacer.rotateroll ~= 0) then
      return self.Owner:ConCommand(("rotateproproll " .. propplacer.rotateroll))
    end
  end
end

SWEP.Place = function(self, model_file, pos, angle)
  propplacer["last_tick"] = engine.TickCount()
  net.Start("Propplacer.Place")
  net.WriteString(model_file)
  net.WriteVector(pos)
  net.WriteAngle(angle)
  return net.SendToServer()
end

local function find_weapon(table, name)
  local retentry = nil
  for key, entry in pairs(table) do
    if (entry.PrintName == name) then
      retentry = entry
    end
  end
  return retentry
end

local function gettraceplane(eyepos, eyeangles)
end

local function _2_(ply, cmd, args, argStr)
  local weapon = find_weapon(ply:GetWeapons(), "PropPlacer")
  if weapon then
    weapon.model = argStr
    util.PrecacheModel( argStr )
    if propplacer.last_model then
      propplacer.last_model:Remove()
      propplacer.last_model = nil
    end
  else
    print("Error: Do not have PropPlacer. Please get the PropPlacer.")
  end
end
concommand.Add("selectprop", _2_, nil, nil, 0)

local function _3_(ply, cmd, args, argStr)
  local weapon = find_weapon(ply:GetWeapons(), "PropPlacer")
  local rot = tonumber(argStr)
  if (weapon and rot) then
    return weapon.angles:Add(Angle(rot, 0, 0))
  else
    return print("Error: No PropPlacer owned or rotation value invalid.")
  end
end
concommand.Add("rotateproppitch", _3_)

local function _4_(ply, cmd, args, argStr)
  local rot = tonumber(args[1])
  if rot then
    propplacer.rotatepitch = rot
  end
end
concommand.Add("+rotateproppitch", _4_)

local function _5_(ply, cmd, args, argStr)
  propplacer.rotatepitch = 0
end
concommand.Add("-rotateproppitch", _5_)

local function _6_(ply, cmd, args, argStr)
  local weapon = find_weapon(ply:GetWeapons(), "PropPlacer")
  local rot = tonumber(argStr)
  if (weapon and rot) then
    return weapon.angles:Add(Angle(0, rot, 0))
  else
    return print("Error: No PropPlacer owned or rotation value invalid.")
  end
end
concommand.Add("rotatepropyaw", _6_)

local function _7_(ply, cmd, args, argStr)
  local rot = tonumber(args[1])
  if rot then
    propplacer.rotateyaw = rot
  end
end
concommand.Add("+rotatepropyaw", _7_)

local function _8_(ply, cmd, args, argStr)
  propplacer.rotateyaw = 0
end
concommand.Add("-rotatepropyaw", _8_)

local function _9_(ply, cmd, args, argStr)
  local weapon = find_weapon(ply:GetWeapons(), "PropPlacer")
  local rot = tonumber(argStr)
  if (weapon and rot) then
    return weapon.angles:Add(Angle(0, 0, rot))
  else
    return print("Error: No PropPlacer owned or rotation value invalid.")
  end
end
concommand.Add("rotateproproll", _9_)

local function _10_(ply, cmd, args, argStr)
  local rot = tonumber(args[1])
  if rot then
    propplacer.rotateroll = rot
  end
end
concommand.Add("+rotateproproll", _10_)

local function _11_(ply, cmd, args, argStr)
  propplacer.rotateroll = 0
  return nil
end
concommand.Add("-rotateproproll", _11_)
